=== meson_options.txt ===
option('build_example', description : 'build the helloworld example', type : 'feature', value : 'auto')
